package com.nisum.webfluxmongodbordermanagement.config;

import lombok.extern.slf4j.Slf4j;
import org.apache.kafka.clients.consumer.ConsumerRecord;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.kafka.annotation.KafkaListener;
import org.springframework.stereotype.Component;

@Component
@Slf4j
public class KafkaListeners {

    @Value("${order_topic}")
    private String topicName;

    @KafkaListener(topics = "${order_topic}",
            groupId = "orders_group",
            containerFactory="consumer_factory")
    public void consume(ConsumerRecord<String, String> record){
        log.info("record consumed to topic: {}, offset {}, partitionkey {}, message {}",
                record.topic(), record.offset(), record.key(), record.value());
    }
}

