package com.nisum.webfluxmongodbordermanagement.controller;

import com.nisum.webfluxmongodbordermanagement.config.KafkaProducer;
import com.nisum.webfluxmongodbordermanagement.entity.User;
import com.nisum.webfluxmongodbordermanagement.entity.UserOrders;
import com.nisum.webfluxmongodbordermanagement.service.UserOrdersService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RestController;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;
import reactor.core.scheduler.Schedulers;

import java.util.List;

@RestController
@Slf4j
public class UserOrdersController {

    @Autowired
    private UserOrdersService userOrdersService;

    @GetMapping("/user-orders")
    public Flux<UserOrders> fetchUserOrdersAndPublish(){
        Flux<UserOrders> userOrdersFlux = userOrdersService.getAllUsersWithOrders();
        userOrdersService.fetchUserOrdersAndPublish(userOrdersFlux);
        return userOrdersFlux;
    }

    @GetMapping("/user-orders/{user_Id}")
    public Flux<UserOrders> getUserWithOrders(@PathVariable("user_Id") String userId){
        Flux<UserOrders> userOrdersFlux = userOrdersService.getUsersWithOrders(userId);
        return userOrdersFlux;
    }


}
