package com.nisum.webfluxmongodbordermanagement.controller;

import com.nisum.webfluxmongodbordermanagement.entity.Order;
import com.nisum.webfluxmongodbordermanagement.entity.User;
import com.nisum.webfluxmongodbordermanagement.service.OrdersService;
import com.nisum.webfluxmongodbordermanagement.service.UserService;
import org.junit.jupiter.api.AfterEach;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.autoconfigure.web.reactive.WebFluxTest;
import org.springframework.boot.test.mock.mockito.MockBean;
import org.springframework.test.context.junit.jupiter.SpringExtension;
import org.springframework.test.web.reactive.server.WebTestClient;
import reactor.core.publisher.Flux;
import reactor.test.StepVerifier;

import static org.mockito.Mockito.when;

@ExtendWith(SpringExtension.class)
@WebFluxTest(OrdersController.class)
public class OrderControllerTest {

    @Autowired
    private WebTestClient webTestClient;


    @MockBean
    private OrdersService ordersService;

    @BeforeEach
    void setUp() {
    }

    @AfterEach
    void tearDown() {
    }

    @Test
    void getAllUsers() {
    }

    @Test
    public void testGetOrders() {
        // Mock data

        Flux<Order> order = Flux.just(new Order("1", "1123", "01", "ooppo01234","ooppo12345678","success"));
        when(ordersService.fetchOrdersAndPublish()).thenReturn(order);

        Flux<Order> responseBody = webTestClient.get().uri("/publish-orders")
            .exchange()
            .expectStatus().isOk()
            .returnResult(Order.class)
            .getResponseBody();
//
        StepVerifier.create(responseBody)
            .expectSubscription()
                .expectNextMatches(p -> p.getUserId().equals("01"))
            .verifyComplete();
}

}

