package com.nisum.webfluxmongodbordermanagement.controller;

import com.nisum.webfluxmongodbordermanagement.entity.User;
import com.nisum.webfluxmongodbordermanagement.service.UserService;
import org.junit.jupiter.api.AfterEach;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.autoconfigure.web.reactive.WebFluxTest;
import org.springframework.boot.test.mock.mockito.MockBean;
import org.springframework.test.context.junit.jupiter.SpringExtension;
import org.springframework.test.web.reactive.server.WebTestClient;
import reactor.core.publisher.Flux;
import reactor.test.StepVerifier;

import static org.mockito.Mockito.when;

@ExtendWith(SpringExtension.class)
@WebFluxTest(UserController.class)
public class UserControllerTest {


    @Autowired
    private WebTestClient webTestClient;


    @MockBean
    private UserService userService;

    @BeforeEach
    void setUp() {
    }

    @AfterEach
    void tearDown() {
    }

    @Test
    void getAllUsers() {
    }

    @Test
    public void testGetUsers() {
        // Mock data

            Flux<User> user = Flux.just(new User("1", "1", "sama", "sama@gmail.com"));
            when(userService.fetchUsersAndPublish()).thenReturn(user);

            Flux<User> responseBody = webTestClient.get().uri("/publish-users")
                    .exchange()
                    .expectStatus().isOk()
                    .returnResult(User.class)
                    .getResponseBody();
//
            StepVerifier.create(responseBody)
                    .expectSubscription()
                    .expectNextMatches(p -> p.getEmailId().equals("sama@gmail.com"))
                    .verifyComplete();
        }

    }


